;****************************************************************************************
;*                           KLINGEL VON DL3UKH                                         *
;*                           ==================                                         *
;*                                                                                      *
;****************************************************************************************
;*                                                                                      *
;*                                                                                      *
;*                           BEGINN: 13.03.13                                           *
;*                           ENDE  : 14.03.13                                           *
;*                         GETESTET: 14.03.13                                           *
;*                                                                                      *
;*                                                                                      *
;*          MIT MELODIE1: BLAUEN BERGEN                                                 *
;*          MIT MELODIE2: SUSANNA                                                       *
;*                                                                                      *
;*                                                                                      *
;****************************************************************************************


    LIST    P=12F629   
    TITLE   "FAHRRAD-KLINGEL"

    ERRORLEVEL -302
    INCLUDE <P12F629.INC>

;--------------------------------------------------------------------------

;ALS OSZILLATOR IST INTERN MIT 4,00MHZ.  (T=0.25S T:=TAKTZEIT)

;--------------------------------------------------------------------------

__CONFIG _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_OFF & _BODEN_OFF & _MCLRE_OFF & _CPD_OFF & _CP_OFF

;--------------------------------------------------------------------------
;PORTZUORDNUNG==>

;EING.  GP0      NICHT BELEGT
;EING.  GP1      NICHT BELEGT
;AUSG.  GP2     "NF"-LOW/HIGH-MELODIE-AUSGANG
;EING.  GP3      NICHT BELEGT
;EING.  GP4      AUSLOESE-TASTER -BEI LOW BEGINNT MELODIE ZUSPIELEN
;EING.  GP5      BEI LOW  SPIELT ES MARTINSHORN-NOTEN-MELODIE
;                BEI HIGH SPIELT ES RETTUNGSDIENST-SIRENE 
;
;--------------------------------------------------------------------------

;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7

;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM

BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM


;MAN BRAUCHT DANN NUR Z.B. SCHREIBEN BANK1 UND DIE BEFEHLE WERDEN AUSGEFUEHRT
;ALSO DEN WIEDERHOLENDEN TEXT BRAUCHT MAN NUR HIER OBEN EINMALIG SCHREIBEN

;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;ALSO DIE RAM-SPEICHER ZUORDNUNG

 

MERK    EQU 0X22           ;ZAEHLER FUER NOTE UND LAENGE, BEI NAECHSTER NOTE/LAENGE +1 ERHOEHT
MERK1   EQU 0X23           ;BEI BIT0 -NUR EINMAL SPIELEN BEI HIGH
                        ;BEI BIT1 -FUER TASTER STOP BEI HIGH
                        ;BEI BIT2 -MERKER FUER MELODIE1=0/LOW + MELODIE2=1/HIGH
                        ;BEI BIT3 -ENDEERKENNUNGSMERKER BEI HIGH ENDE
                        ;BEI BIT4 -MERKER
                        ;BEI BIT5 -MERKER SIRENE
                        ;BEI BIT7 -PAUSENERKENNUNGSMERKER BEI HIGH PAUSE (KEIN TON)
MERK2   EQU 0X24        ;GESCHWINDIGKEITSMERKER / ZWISCHENSPEICHER
ZAE     EQU 0X25        ;ZAEHLMERKER
GESCH   EQU 0X26        ;GESCHINDIGKEIT
P_WERT  EQU 0X27        ;PAUSEN-WERT BEI 1-HIGH=PAUSE EIN   0-LOW=PAUSE AUS ALSO KEINE PAUSE
                        ;ZWISCHEN DEN EINZELNEN NOTEN
NO      EQU 0X28        ;NOTE
LA      EQU 0X29        ;LAENGE


;--------------------------------------------------------------------------
;SPEICHERANFANG BZW. BEGINN

    ORG 0X0000
    GOTO MAIN       ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    RETFIE          ; BEI EINEM INTERRUPT SOFORT EIN RETURN


    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM   MIT DEM NAMEN "MAIN"           *
;*                              23.08.10                                     *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK0
                        CLRF    GPIO     
                        MOVLW   0X07                    ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON

                        BANK1
                        MOVLW   B'11111011'             ;GP2 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1))
                        MOVWF   TRISIO

;KALIBRIERUNGSWERT FR DEN INTERNEN OSZILLATOR AM ENDE DES HAUPTSPEICHERS BERNEHMEN
                        CALL    0X03FF                  
                        MOVWF   OSCCAL

;INIT TIMER 0 FUER 10MSEC FUER ZEITSCHLEIFE 
;(HIER MUSS MAN IN DEM DATENBLATT (DATASHEET) BEI WWW.MICROCHIP.COM (EIN *.PDF-FILE) NACHSEHEN, WIE ALLES FUNKTIONIERT)
                        MOVLW   B'10000111'             ;BIT0-2 111=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG      
                        BANK0

;---------------INITIALISIERUNG--ZU--ENDE-----------------------


;MELODIE-ABSPIELUNG
NEU_MEL 
    BCF     GPIO, GP2         ;NF AUS, ES FLIESST KEIN STROM DURCH NF-SCHALTTRANSISTOREN MEHR
    CLRF    MERK

NEU_TA  
    BTFSC   GPIO, GP4         ;TASTERABFRAGE
    GOTO    NEU_TA
    
    BTFSS   GPIO, GP5         ;DIP-SCHALTER AN RB7 -LOW DANN MELODIE1  -HIGH DANN MELODIE2    
    GOTO    AAA1
    BSF     MERK1, BIT2
    GOTO    L_SP
    
AAA1    
    BCF     MERK1, BIT2


;-----------

L_SP
    MOVLW   D'10'
    MOVWF   MERK2
NEU_M1
    CALL    I_T0_5          ;5MS PAUSE * 10 =50MS
NEU_M2
    BTFSC   INTCON, T0IF        
    GOTO    NEU_M2
    BTFSC   GPIO, GP4         ;DEN TASTER MUSS MAN 50MSEC DRUECKEN DANN KOMMT EIN TON
    GOTO    NEU_MEL            
  
    DECFSZ  MERK2, F
    GOTO    NEU_M1


;LIED ODER SIRENE ABFRAGE
;    BTFSS   MERK1, BIT2     
;    GOTO    MELODIE
;    GOTO    SIRENE

;GESCHWINDIGKEIT WIRD AUS SPEICHER GELESEN
MELODIE   
    BTFSS   MERK1, BIT2
    GOTO    NO1
    CALL    NOTE1
    MOVWF   GESCH
    MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH
    GOTO    NO2

NO1
    CALL    NOTE2
    MOVWF   GESCH
    MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH

;GLEICH FUER NEUE SPEICHER-ADRESSE FUER KOMMENDEN PAUSENWERT LESEN ALSO +1 SPEICHER ERHOEHEN
NO2 INCF    MERK, F         

;PAUSENWERT WIRD AUS SPEICHER GELESEN
    BTFSS   MERK1, BIT2
    GOTO    NO3
    CALL    NOTE1
    MOVWF   P_WERT
    MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH
    GOTO    NO4

NO3
    CALL    NOTE2
    MOVWF   P_WERT
    MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH

;GLEICH FUER NEUE NOTEN+LAENGEN-ADRESSE FUER KOMMENDE NOTE+LAENGE ERRECHNEN
NO4 INCF    MERK, F         ;IMMER 1 WEITERZAEHLEN ALSO NEUE NOTE BZW. TONHOEHEN-SPEICHERADRESSE


;NEUE NOTE SPIELEN
NEU_NO  
    BCF     GPIO, GP2         ;NF AUS, ES FLIESST KEIN STROM DURCH NF-SCHALTTRANSISTOREN MEHR

    BCF     MERK1, BIT3     ;RUECKSETZEN TON-LAENGENZEIT IST ABGELAUFEN
    BCF     MERK1, BIT7     ;NOTENPAUSEN MERKER RUECKSETZEN

;TONLAENGE + NOTE WIRD AUS SPEICHER GELESEN
    BTFSS   MERK1, BIT2
    GOTO    NI1

    CALL    NOTE1
    MOVWF   NO
    MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH
    GOTO    NI2

NI1
    CALL    NOTE2
    MOVWF   NO
    MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH

NI2 BTFSS   MERK1, BIT2
    GOTO    NI3
    CALL    LAENGE1
    MOVWF   LA
    MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH
    GOTO    NI4

NI3 CALL    LAENGE2
    MOVWF   LA
    MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH

;GLEICH NEUE NOTEN+LAENGEN-ADRESSE FUER KOMMENDE NOTE+LAENGE ERRECHNEN
NI4 INCF    MERK, F         ;IMMER 1 WEITERZAEHLEN ALSO NEUE NOTE BZW. TONHOEHEN-SPEICHERADRESSE

;MELODIE ENDE ERKENNUNG
    MOVLW   0XFF
    SUBWF   NO, W           ;DAS ENDEBYTE MUSS AM ENDE DER MELODIE FF HEX SEIN, BEI NOTE1 UND NOTE2
    BTFSS   STATUS, Z
    GOTO    WEIT4
    GOTO    NEU_MEL

;NACHFRAGEN OB EINE NOTEN-PAUSE VORLIEGT
WEIT4   
    MOVLW   0X00
    SUBWF   NO, W
    BTFSC   STATUS, Z
    BSF     MERK1, BIT7     ;NOTENPAUSEN MERKER SETZEN

;PAUSE ZWISCHEN DEN NOTEN
SPIELE  
    BTFSS   P_WERT, BIT0    ;BEI P_WERT=1 (BIT0) ERFOLGT PAUSE ZWISCHEN DEN NOTEN 
                            ;BEI P_WERT=0 (BIT0) KEINE PAUSE ZWISCHEN DEN NOTEN
    GOTO    SPIE3

    MOVF    GESCH, W
    MOVWF   MERK2

SPIE1   
    CALL    I_T0_3          ;3MS PAUSE ZWISCHEN DEN EINZELNEN NOTEN
SPIE2   
    BTFSS   INTCON, T0IF    ;UND DANN MIT GESCH(WINDIGKEIT) MULTIPLIZIERT
    GOTO    SPIE2           ;BEI GESCH=15 ==> 15*3MS=45MS PAUSE // ALSO PROPORTIONAL ZUM TEMPO

    DECFSZ  MERK2, F
    GOTO    SPIE1

SPIE3   
    MOVF    GESCH, W
    MOVWF   MERK2
    CALL    I_T0_5

;MELODIE WIRD JETZT AUSGEGEBEN, VORHER WURDEN ALLE DATEN ZWISCHENGESPEICHERT //NO LA + MERK1-BIT7 GESCH 

SP0 MOVF    NO, W
    MOVWF   ZAE
    BTFSS   MERK1, BIT7     ;BEI PAUSE KEINE NF
    BSF     GPIO, GP2         ;NF EIN


SP1 NOP             ;4T
    NOP             ;4T
    NOP             ;4T
    NOP             ;4T
    NOP             ;4T GES.: 20T

    NOP             ;4T
    NOP             ;4T
    NOP             ;4T GES.: 32

    BTFSC   INTCON, T0IF    ;8T BEI SPRUNG   GES.:40T
    CALL    Z_LAEN

    BTFSC   MERK1, BIT3     ;8T BEI SPRUNG   GES.:48T
    GOTO    NEU_NO

    DECFSZ  ZAE, F          ;4T
    GOTO    SP1             ;8T GESAMT:60T  /// 60T*0.25S=15S

    MOVF    NO, W           
    MOVWF   ZAE         
    BTFSS   MERK1, BIT7     ;BEI PAUSE KEINE NF  
    BCF     GPIO, GP2         ;NF AUS              

SP2 NOP             ;4T
    NOP             ;4T
    NOP             ;4T
    NOP             ;4T
    NOP             ;4T GES.: 20T

    NOP             ;4T
    NOP             ;4T
    NOP             ;4T GES.: 32

    BTFSC   INTCON, T0IF    ;8T BEI SPRUNG   GES.:40T
    CALL    Z_LAEN

    BTFSC   MERK1, BIT3     ;8T BEI SPRUNG   GES.:48T
    GOTO    NEU_NO

    DECFSZ  ZAE, F          ;4T
    GOTO    SP2             ;8T GESAMT:60T  /// 60T*0.25S=15S
    GOTO    SP0


;*****************************************************************************
;*                            INIT TIMER 0   FUERS 5MS                       *
;*                              28.04.07                                     *
;*****************************************************************************
I_T0_5  
    MOVLW   D'236'
    MOVWF   TMR0
    BCF     INTCON, T0IF    ;OVERFLOW = 0
    RETURN

;ZEITBERECHNUNG FUER 5MS
;PRESCALER 256X  +  SYSTEM 4X  ====> 256*4*0.25S=256S
;256S*D'20'=5MS
;TMR0 ALSO D'256'-D'20'=D'236' ENTSPRICHT CA. 5MS
;236 DEZIMAL OBEN EINTRAGEN

;*****************************************************************************
;*                            INIT TIMER 0   FUERS 3MS                       *
;*                              28.04.07                                     *
;*****************************************************************************
I_T0_3  
    MOVLW   D'244'
    MOVWF   TMR0
    BCF     INTCON, T0IF    ;OVERFLOW = 0
    RETURN

;ZEITBERECHNUNG FUER 3MS
;PRESCALER 256X  +  SYSTEM 4X  ====> 256*4*0.25S=256S
;256S*D'12'=3MS
;TMR0 ALSO D'256'-D'12'=D'244' ENTSPRICHT CA. 3MS
;244 DEZIMAL OBEN EINTRAGEN

;*****************************************************************************
;*                              ZEIT-LAENGE                                  *
;*                              ES WIRD ABGEBROCHEN WENN ZEIT ERREICHT       *
;*****************************************************************************
Z_LAEN  
    CALL    I_T0_5
    DECFSZ  MERK2, F
    GOTO    EY
    DECFSZ  LA, F
    GOTO    SPZ
    BSF     MERK1, BIT3     ;ABBRUCH        
    BCF     GPIO, GP2         ;NF AUS, ES FLIESST KEIN STROM DURCH NF-SCHALTTRANSISTOREN MEHR
    GOTO    EY              ;NEUE NOTE

SPZ MOVF    GESCH, W
    MOVWF   MERK2

EY  RETURN

;*****************************************************************************
;*                              HOCH- + RUNTER- FAHREN DER FREQUENZ          *
;*                              FREQUENZ HALTEN                              *
;*****************************************************************************
Z_LAE   
    CALL    I_T0_5
    DECFSZ  MERK2, F
    GOTO    EYZ
    DECFSZ  LA, F
    GOTO    SPZZ
    BSF     MERK1, BIT3     ;ABBRUCH        
    GOTO    EYZ             ;NEUE NOTE

SPZZ    
    MOVF    GESCH, W
    MOVWF   MERK2

EYZ RETURN


    ORG 0100H

;*****************************************************************************
;*                             TON-HOEHE(NOTE)-VON-MELODIE1                  *
;*                              07.05.07                                     *
;*                             BLAUEN-BERGEN...                              *
;*                                                                           *
;*****************************************************************************
NOTE1   
    MOVLW   H'01'   ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH

    MOVF    MERK,W  ; ZAEHLER DER TONHOEHE
    ADDWF   PCL,F   ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  ??

    RETLW D'12'     ;HIER KOMMT DER GESCHWINDIGKEITSWERT REIN
                    ;ALSO WIE SCHNELL DIE MELODIE ABGESPIELT WERDEN SOLL
                    ;KLEINER WERT (ES GEHT SCHNELL) GROSSER WERT (ES GEHT LANGSAM)


    RETLW D'1'  ;BEI 1 KOMMT EINE PAUSE ZWISCHEN DEN NOTEN ; BEI 0 KOMMT KEINE PAUSE ZWISCHEN DEN NOTEN

;HIER KOMMEN JETZT DIE NOTEN FUER DIE MELODIE
;MAN KANN AENDEN, WIE MAN WILL
;ABER DIE REIHEFOLGE OBEN MIT GESCHWINDIGKEIT + PAUSE-ZWISCHEN-DEN-NOTEN MUSS IMMER SO SEIN !!
;HIER UNTEN KOENNTE MAN BELIEBIGE NOTEN UND PAUSEN EINTRAGEN; DIE LAENGENZUORDNUNG MUSS ABER STIMMEN
   RETLW D'151'    ;A-T
   RETLW D'127'    ;C
   RETLW D'95'     ;F
   RETLW D'95'     ;F
   RETLW D'113'    ;D
   RETLW D'127'    ;C
   RETLW D'151'    ;A-T
   RETLW D'127'    ;C
   RETLW D'95'     ;F
   RETLW D'95'     ;F
   RETLW D'0'      ;PAUSE
   RETLW D'95'     ;F
   RETLW D'85'     ;G
   RETLW D'76'     ;A
   RETLW D'76'     ;A
   RETLW D'64'     ;C-H
   RETLW D'64'     ;C-H
   RETLW D'64'     ;C-H
   RETLW D'76'     ;A
   RETLW D'85'     ;G
   RETLW D'85'     ;G
   RETLW D'0'      ;PAUSE
   RETLW D'64'     ;C-H
   RETLW D'72'     ;AIS
   RETLW D'76'     ;A
   RETLW D'76'     ;A
   RETLW D'76'     ;A
   RETLW D'76'     ;A
   RETLW D'85'     ;G
   RETLW D'95'     ;F
   RETLW D'95'     ;F
   RETLW D'95'     ;F
   RETLW D'113'    ;D
   RETLW D'113'    ;D
   RETLW D'113'    ;D
   RETLW D'113'    ;D
   RETLW D'85'     ;G
   RETLW D'95'     ;F
   RETLW D'101'    ;E
   RETLW D'113'    ;D
   RETLW D'127'    ;C
   RETLW D'127'    ;C
   RETLW D'72'     ;AIS
   RETLW D'85'     ;G
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'95'     ;F
   RETLW D'95'     ;F
   RETLW D'0'      ;PAUSE
   RETLW D'151'    ;A-T
   RETLW D'127'    ;C
   RETLW D'95'     ;F
   RETLW D'95'     ;F
   RETLW D'113'    ;D
   RETLW D'127'    ;C
   RETLW D'151'    ;A-T
   RETLW D'127'    ;C
   RETLW D'95'     ;F
   RETLW D'95'     ;F
   RETLW D'0'      ;PAUSE
   RETLW D'95'     ;F
   RETLW D'85'     ;G
   RETLW D'76'     ;A
   RETLW D'76'     ;A
   RETLW D'64'     ;C-H
   RETLW D'64'     ;C-H
   RETLW D'64'     ;C-H
   RETLW D'76'     ;A
   RETLW D'85'     ;G
   RETLW D'85'     ;G
   RETLW D'0'      ;PAUSE
   RETLW D'64'     ;C-H
   RETLW D'72'     ;AIS
   RETLW D'76'     ;A
   RETLW D'76'     ;A
   RETLW D'85'     ;G
   RETLW D'95'     ;F
   RETLW D'95'     ;F
   RETLW D'113'    ;D
   RETLW D'113'    ;D
   RETLW D'85'     ;G
   RETLW D'95'     ;F
   RETLW D'101'    ;E
   RETLW D'113'    ;D
   RETLW D'127'    ;C
   RETLW D'127'    ;C
   RETLW D'72'     ;AIS
   RETLW D'85'     ;G
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'95'     ;F
   RETLW D'95'     ;F
   RETLW D'0'      ;PAUSE

   RETLW 0XFF  ;ENDE MUSS IMMER FF HEX SEIN !!!



    ORG 0180H

;*****************************************************************************
;*                             TON-LAENGE-VON-MELODIE1                       *
;*                              28.04.05                                     *
;*****************************************************************************
LAENGE1 
    MOVLW H'01'     ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF PCLATH

    MOVF    MERK,W  ; ZAEHLER DER LAENGE
    ADDWF   PCL,F   ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  ??

    RETLW D'12'     ;HIER KOMMT DER GESCHWINDIGKEITSWERT REIN
                    ;ALSO WIE SCHNELL DIE MELODIE ABGESPIELT WERDEN SOLL
                    ;KLEINER WERT (ES GEHT SCHNELL) GROSSER WERT (ES GEHT LANGSAM)


    RETLW D'1'      ;BEI 1 KOMMT EINE PAUSE ZWISCHEN DEN NOTEN ; BEI 0 KOMMT KEINE PAUSE ZWISCHEN DEN NOTEN


;HIER KOMMEN JETZT DIE TONLAENGEN FUER DIE MELODIE
;VORHER WURDEN DIE NOTEN ERST REINCOPIERT, NUR ZUR SICHERHEIT DAMIT MAN DANN 
;JEDER NOTE DIE TONLAENGE ZUORDNEN KANN
;ALSO NUR DAMIT MAN NICHT DURCHEINANDER KOMMT (JEDE NOTE HAT IHRE TONLAENGE)

;HIER KOMMEN JETZT DIE NOTENLAENGE FUER DIE MELODIE
   RETLW D'4'  ;1/8;   RETLW D'151'    ;A-T
   RETLW D'4'  ;1/8;   RETLW D'127'    ;C
   RETLW D'8'  ;1/4;   RETLW D'95'     ;F
   RETLW D'8'  ;1/4;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'127'    ;C
   RETLW D'4'  ;1/8;   RETLW D'151'    ;A-T
   RETLW D'4'  ;1/8;   RETLW D'127'    ;C
   RETLW D'16' ;1/2;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'0'      ;PAUSE
   RETLW D'4'  ;1/8;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'85'     ;G
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'4'  ;1/8;   RETLW D'64'     ;C-H
   RETLW D'4'  ;1/8;   RETLW D'64'     ;C-H
   RETLW D'4'  ;1/8;   RETLW D'64'     ;C-H
   RETLW D'4'  ;1/8;   RETLW D'76'     ;A
   RETLW D'16' ;1/2;   RETLW D'85'     ;G
   RETLW D'4'  ;1/8;   RETLW D'85'     ;G
   RETLW D'4'  ;1/8;   RETLW D'0'      ;PAUSE
   RETLW D'4'  ;1/8;   RETLW D'64'     ;C-H
   RETLW D'4'  ;1/8;   RETLW D'72'     ;AIS
   RETLW D'4'  ;1/8;   RETLW D'76'     ;A
   RETLW D'4'  ;1/8;   RETLW D'76'     ;A
   RETLW D'6'  ;1/8_V;   RETLW D'76'     ;A
   RETLW D'2'  ;1/16;   RETLW D'76'     ;A
   RETLW D'4'  ;1/8;   RETLW D'85'     ;G
   RETLW D'4'  ;1/8;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'113'    ;D
   RETLW D'6'  ;1/8_V;   RETLW D'113'    ;D
   RETLW D'2'  ;1/16;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'85'     ;G
   RETLW D'4'  ;1/8;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'4'  ;1/8;   RETLW D'113'    ;D
   RETLW D'8'  ;1/4;   RETLW D'127'    ;C
   RETLW D'8'  ;1/4;   RETLW D'127'    ;C
   RETLW D'4'  ;1/8;   RETLW D'72'     ;AIS
   RETLW D'4'  ;1/8;   RETLW D'85'     ;G
   RETLW D'2'  ;1/16;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'16' ;1/2;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'0'      ;PAUSE
   RETLW D'4'  ;1/8;   RETLW D'151'    ;A-T
   RETLW D'4'  ;1/8;   RETLW D'127'    ;C
   RETLW D'8'  ;1/4;   RETLW D'95'     ;F
   RETLW D'8'  ;1/4;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'127'    ;C
   RETLW D'4'  ;1/8;   RETLW D'151'    ;A-T
   RETLW D'4'  ;1/8;   RETLW D'127'    ;C
   RETLW D'16' ;1/2;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'0'      ;PAUSE
   RETLW D'4'  ;1/8;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'85'     ;G
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'4'  ;1/8;   RETLW D'64'     ;C-H
   RETLW D'4'  ;1/8;   RETLW D'64'     ;C-H
   RETLW D'4'  ;1/8;   RETLW D'64'     ;C-H
   RETLW D'4'  ;1/8;   RETLW D'76'     ;A
   RETLW D'16' ;1/2;   RETLW D'85'     ;G
   RETLW D'4'  ;1/8;   RETLW D'85'     ;G
   RETLW D'4'  ;1/8;   RETLW D'0'      ;PAUSE
   RETLW D'4'  ;1/8;   RETLW D'64'     ;C-H
   RETLW D'4'  ;1/8;   RETLW D'72'     ;AIS
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'4'  ;1/8;   RETLW D'85'     ;G
   RETLW D'4'  ;1/8;   RETLW D'95'     ;F
   RETLW D'8'  ;1/4;   RETLW D'95'     ;F
   RETLW D'8'  ;1/4;   RETLW D'113'    ;D
   RETLW D'8'  ;1/4;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'85'     ;G
   RETLW D'4'  ;1/8;   RETLW D'95'     ;F
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'4'  ;1/8;   RETLW D'113'    ;D
   RETLW D'8'  ;1/4;   RETLW D'127'    ;C
   RETLW D'8'  ;1/4;   RETLW D'127'    ;C
   RETLW D'4'  ;1/8;   RETLW D'72'     ;AIS
   RETLW D'4'  ;1/8;   RETLW D'85'     ;G
   RETLW D'4'  ;1/8;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'16' ;1/2;   RETLW D'95'     ;F
   RETLW D'8'  ;1/4;   RETLW D'95'     ;F
   RETLW D'32' ;1;   RETLW D'0'      ;PAUSE

   RETLW 0XFF  ;ENDE  MUSS IMMER FF HEX SEIN

;TIEFE OKTAVE
;   RETLW D'254'    ;C_T
;   RETLW D'240'    ;CIS_T
;   RETLW D'227'    ;D_T
;   RETLW D'214'    ;DIS_T
;   RETLW D'202'    ;E_T
;   RETLW D'191'    ;F_T
;   RETLW D'180'    ;FIS_T
;   RETLW D'170'    ;G-T
;   RETLW D'160'    ;GIS-T
;   RETLW D'151'    ;A-T
;   RETLW D'143'    ;AIS-T
;   RETLW D'135'    ;H-T
;
;NORMALE OKTAVE
;   RETLW D'127'    ;C
;   RETLW D'120'    ;CIS
;   RETLW D'113'    ;D
;   RETLW D'107'    ;DIS
;   RETLW D'101'    ;E
;   RETLW D'95'     ;F
;   RETLW D'90'     ;FIS
;   RETLW D'85'     ;G
;   RETLW D'80'     ;GIS
;   RETLW D'76'     ;A
;   RETLW D'72'     ;AIS
;   RETLW D'67'     ;H
;
;HOHE OKTAVE
;   RETLW D'64'     ;C-H
;   RETLW D'60'     ;CIS-H
;   RETLW D'57'     ;D-H
;   RETLW D'54'     ;DIS-H
;   RETLW D'51'     ;E-H
;   RETLW D'48'     ;F-H
;   RETLW D'45'     ;FIS-H
;   RETLW D'43'     ;G-H
;   RETLW D'40'     ;GIS-H
;   RETLW D'38'     ;A-H
;   RETLW D'36'     ;AIS-H
;   RETLW D'34'     ;H-H

;   RETLW D'0'      ;PAUSE

    ORG 0200H

;*****************************************************************************
;*                             TON-HOEHE(NOTE)-VON-MELODIE2                  *
;*                              07.05.07                                     *
;*                                                                           *
;*                                                                           *
;*****************************************************************************
NOTE2   
    MOVLW   H'02'   ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH

    MOVF    MERK,W  ; ZAEHLER DER TONHOEHE
    ADDWF   PCL,F   ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  ??

	RETLW D'12'     ;HIER KOMMT DER GESCHWINDIGKEITSWERT REIN
			;ALSO WIE SCHNELL DIE MELODIE ABGESPIELT WERDEN SOLL
			;KLEINER WERT (ES GEHT SCHNELL) GROSSER WERT (ES GEHT LANGSAM)


	RETLW D'1'	;BEI 1 KOMMT EINE PAUSE ZWISCHEN DEN NOTEN ; BEI 0 KOMMT KEINE PAUSE ZWISCHEN DEN NOTEN

;HIER KOMMEN JETZT DIE NOTEN FUER DIE MELODIE
;MAN KANN AENDEN, WIE MAN WILL
;ABER DIE REIHEFOLGE OBEN MIT GESCHWINDIGKEIT + PAUSE-ZWISCHEN-DEN-NOTEN MUSS IMMER SO SEIN !!
;HIER UNTEN KOENNTE MAN BELIEBIGE NOTEN UND PAUSEN EINTRAGEN; DIE LAENGENZUORDNUNG MUSS ABER STIMMEN
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'90'     ;FIS
   RETLW D'76'     ;A
   RETLW D'76'     ;A
   RETLW D'67'     ;H
   RETLW D'76'     ;A
   RETLW D'90'     ;FIS
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'90'     ;FIS
   RETLW D'90'     ;FIS
   RETLW D'101'    ;E
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'0'      ;PAUSE
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'90'     ;FIS
   RETLW D'76'     ;A
   RETLW D'76'     ;A
   RETLW D'67'     ;H
   RETLW D'76'     ;A
   RETLW D'90'     ;FIS
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'90'     ;FIS
   RETLW D'90'     ;FIS
   RETLW D'101'    ;E
   RETLW D'101'    ;E
   RETLW D'113'    ;D
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'90'     ;FIS

   RETLW D'76'     ;A
   RETLW D'76'     ;A
   RETLW D'67'     ;H
   RETLW D'76'     ;A
   RETLW D'90'     ;FIS
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'90'     ;FIS
   RETLW D'90'     ;FIS
   RETLW D'101'    ;E
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'0'      ;PAUSE
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'90'     ;FIS
   RETLW D'76'     ;A
   RETLW D'76'     ;A
   RETLW D'67'     ;H
   RETLW D'76'     ;A
   RETLW D'90'     ;FIS
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'90'     ;FIS
   RETLW D'90'     ;FIS
   RETLW D'101'    ;E
   RETLW D'101'    ;E
   RETLW D'113'    ;D
   RETLW D'113'    ;D

   RETLW D'0'      ;PAUSE
   RETLW D'85'     ;G
   RETLW D'85'     ;G
   RETLW D'67'     ;H
   RETLW D'67'     ;H
   RETLW D'67'     ;H
   RETLW D'76'     ;A
   RETLW D'76'     ;A
   RETLW D'90'     ;FIS
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'90'     ;FIS
   RETLW D'76'     ;A
   RETLW D'90'     ;FIS
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'90'     ;FIS
   RETLW D'90'     ;FIS
   RETLW D'101'    ;E
   RETLW D'101'    ;E
   RETLW D'113'    ;D

   RETLW D'0'      ;PAUSE
   RETLW D'85'     ;G
   RETLW D'85'     ;G
   RETLW D'67'     ;H
   RETLW D'67'     ;H
   RETLW D'67'     ;H
   RETLW D'76'     ;A
   RETLW D'76'     ;A
   RETLW D'90'     ;FIS
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'90'     ;FIS
   RETLW D'76'     ;A
   RETLW D'76'     ;A
   RETLW D'67'     ;H
   RETLW D'76'     ;A
   RETLW D'90'     ;FIS
   RETLW D'113'    ;D
   RETLW D'101'    ;E
   RETLW D'90'     ;FIS
   RETLW D'90'     ;FIS
   RETLW D'101'    ;E
   RETLW D'101'    ;E
   RETLW D'113'    ;D
   RETLW D'0'      ;PAUSE
   RETLW D'113'    ;D
   RETLW D'0'      ;PAUSE

   RETLW 0XFF  ;ENDE MUSS IMMER FF HEX SEIN !!!



;   RETLW D'48' ;1_V
;   RETLW D'32' ;1    
;   RETLW D'24' ;1/2_V  
;   RETLW D'16' ;1/2    
;   RETLW D'12' ;1/4_V
;   RETLW D'8'  ;1/4
;   RETLW D'6'  ;1/8_V
;   RETLW D'4'  ;1/8
;   RETLW D'3'  ;1/16_V
;   RETLW D'2'  ;1/16


    ORG 0300H
;*****************************************************************************
;*                             TON-LAENGE-VON-MELODIE2                       *
;*                              28.04.05                                     *
;*****************************************************************************
LAENGE2 
    MOVLW H'03'     ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF PCLATH

    MOVF    MERK,W  ; ZAEHLER DER LAENGE
    ADDWF   PCL,F   ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  ??


	RETLW D'12'     ;HIER KOMMT DER GESCHWINDIGKEITSWERT REIN
			;ALSO WIE SCHNELL DIE MELODIE ABGESPIELT WERDEN SOLL
			;KLEINER WERT (ES GEHT SCHNELL) GROSSER WERT (ES GEHT LANGSAM)


	RETLW D'1'	;BEI 1 KOMMT EINE PAUSE ZWISCHEN DEN NOTEN ; BEI 0 KOMMT KEINE PAUSE ZWISCHEN DEN NOTEN


;HIER KOMMEN JETZT DIE TONLAENGEN FUER DIE MELODIE
;VORHER WURDEN DIE NOTEN ERST REINCOPIERT, NUR ZUR SICHERHEIT DAMIT MAN DANN 
;JEDER NOTE DIE TONLAENGE ZUORDNEN KANN
;ALSO NUR DAMIT MAN NICHT DURCHEINANDER KOMMT (JEDE NOTE HAT IHRE TONLAENGE)


;HIER KOMMEN JETZT DIE NOTENLAENGE FUER DIE MELODIE
   RETLW D'4'  ;1/8;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'12' ;1/4_V;   RETLW D'76'     ;A
   RETLW D'4'  ;1/8;   RETLW D'67'     ;H
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'12' ;1/4_V;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'113'    ;D
   RETLW D'16' ;1/2;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'0'      ;PAUSE
   RETLW D'4'  ;1/8;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'12' ;1/4_V;   RETLW D'76'     ;A
   RETLW D'4'  ;1/8;   RETLW D'67'     ;H
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'12' ;1/4_V;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'101'    ;E
   RETLW D'24' ;1/2_V;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS

   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'12' ;1/4_V;   RETLW D'76'     ;A
   RETLW D'4'  ;1/8;   RETLW D'67'     ;H
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'12' ;1/4_V;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'113'    ;D
   RETLW D'16' ;1/2;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'0'      ;PAUSE
   RETLW D'4'  ;1/8;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'12' ;1/4_V;   RETLW D'76'     ;A
   RETLW D'4'  ;1/8;   RETLW D'67'     ;H
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'12' ;1/4_V;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'101'    ;E
   RETLW D'24' ;1/2_V;   RETLW D'113'    ;D
   RETLW D'24' ;1/2_V;   RETLW D'113'    ;D

   RETLW D'8'  ;1/4;   RETLW D'0'      ;PAUSE
   RETLW D'16' ;1/2;   RETLW D'85'     ;G
   RETLW D'16' ;1/2;   RETLW D'85'     ;G
   RETLW D'8'  ;1/4;   RETLW D'67'     ;H
   RETLW D'16' ;1/2;   RETLW D'67'     ;H
   RETLW D'8'  ;1/4;   RETLW D'67'     ;H
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'113'    ;D
   RETLW D'24' ;1/2_V;   RETLW D'101'    ;E
   RETLW D'4'  ;1/8;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'101'    ;E
   RETLW D'24' ;1/2_V;   RETLW D'113'    ;D

   RETLW D'8'  ;1/4;   RETLW D'0'      ;PAUSE
   RETLW D'16' ;1/2;   RETLW D'85'     ;G
   RETLW D'16' ;1/2;   RETLW D'85'     ;G
   RETLW D'8'  ;1/4;   RETLW D'67'     ;H
   RETLW D'16' ;1/2;   RETLW D'67'     ;H
   RETLW D'8'  ;1/4;   RETLW D'67'     ;H
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'113'    ;D
   RETLW D'24' ;1/2_V;   RETLW D'101'    ;E
   RETLW D'4'  ;1/8;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'12' ;1/4_V;   RETLW D'76'     ;A
   RETLW D'4'  ;1/8;   RETLW D'67'     ;H
   RETLW D'8'  ;1/4;   RETLW D'76'     ;A
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'113'    ;D
   RETLW D'4'  ;1/8;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'90'     ;FIS
   RETLW D'8'  ;1/4;   RETLW D'101'    ;E
   RETLW D'8'  ;1/4;   RETLW D'101'    ;E
   RETLW D'24' ;1/2_V;   RETLW D'113'    ;D
   RETLW D'8'  ;1/4;   RETLW D'0'      ;PAUSE
   RETLW D'24' ;1/2_V;   RETLW D'113'    ;D
   RETLW D'32' ;1  ;   RETLW D'0'      ;PAUSE

   RETLW 0XFF  ;ENDE  MUSS IMMER FF HEX SEIN



    END
